
// TestApps.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/* Tests of the application-related methods in Jau.
*/

import java.util.*;
import com.sun.jna.platform.win32.WinDef.*;


public class TestApps
{
  public static void main (String args[])
  {
    System.out.println("--------------- List all app paths ----------------------");
    List<String> apps =  Jau.appListPaths();
    for(String app : apps)
      System.out.println(app);

    System.out.println();
    System.out.println("Apps dir: " + Jau.appsDir());

    System.out.println();
    System.out.println("Desktop dir: " + Jau.desktopPath());

    System.out.println("\n------------------- list libre-related apps ----------------");
    apps =  Jau.appListPaths("libre");
    for(String app : apps)
      System.out.println(app);

    System.out.println("\n-------------------- find app for notepad++ -------------------");
    System.out.println(Jau.appFindPath("notepad++"));

    System.out.println();
    HWND hWnd = Jau.appGetHandle("impress");    // will be null if impress is not running
    System.out.println("impress (raw) handle: " + hWnd);

    System.out.println();
    hWnd = Jau.appGetHandle("notepad++");
    System.out.println("notepad++ (raw) handle: " + hWnd);
    System.out.println("notepad++ (string) handle: " + Jau.handleString(hWnd));
  }  // end of main()

}  // end of TestApps class
