
// TestPIDs.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/* Tests of Jau's process-related methods.
   You probably don't want to use these directly. Look at TestRun.java for
   how to start applications.
*/


import java.util.*;
import com.sun.jna.platform.win32.WinDef.*;


public class TestPIDs
{
  public static void main (String args[])
  {
    System.out.println("Running calc using AutoIt approach");
    int pid = AutoItX3.INSTANCE.AU3_Run("calc", ".", Jau.SW_SHOWNORMAL);  // starts the calculator

    Jau.sleep(1000);   // give time for window to start executing, or handle will be null!!
    HWND hWnd = Jau.processGetHandle(pid);

    System.out.println("  PID: " + pid + "; handle: " + Jau.handleString(hWnd));
    System.out.println("  PID: " + pid + "; application: " + Jau.processGetApp(pid));

    System.out.println("----------------------- chrome PIDs ----------------------");
    List<Integer> cpids = Jau.processListPIDs("chrome");
    System.out.println("No. of PIDs associated with chrome: " + cpids.size());
    for(Integer cpid : cpids)
      System.out.println("PID: " + cpid);

    System.out.println("----------------------- map of apps ----------------------");
    Map<Integer,String> mapApps = Jau.processMapApps();
    System.out.println("Size of map: " + mapApps.size()); 
    for (Map.Entry<Integer,String> entry : mapApps.entrySet())   // print the map
      System.out.println( entry.getKey() + ": " + entry.getValue() );
    System.out.println("-----------------------");

    if (hWnd != null) {
      Jau.sleep(2000);
      Jau.winClose(hWnd);
    }
    else
      System.out.println("Handle is null");
  }  // end of main()

}  // end of TestPIDs class
