
// TestRun.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/* This example contains lots of different tests of Jau.run() 
   with different apps, and arguments.

   To try out one, uncomment a single call to Jau.run().

   The application is started (if possible), and then closed after a delay
   of 2 secs.
*/


import java.util.*;
import com.sun.jna.platform.win32.WinDef.*;


public class TestRun
{
  public static void main (String args[])
  {
    HWND hWnd = Jau.run("calc");   // starts the calculator

    // HWND hWnd = Jau.run("xysdfgss");   // fails since there's no app called this

    // HWND hWnd = Jau.run("notepad");

    // HWND hWnd = Jau.run("impress", 20000);  
         // an extra long wait since LibreOffice starts slowly the very first time it is opened
         // but fails since the impress window cannot be detected;
         // this is because the impress handle is not the handle of the first window that appears

    // HWND hWnd = Jau.run("impress", "Untitled", 10000);  
             // the title text must start the title
             // succeeds since eventual impress window starts with "Untitled"

/*
    Jau.winTitleMatchMode(Jau.MATCH_ANY);    // allows title match anywhere in the title
    HWND hWnd = Jau.run("impress", "LibreOffice"); 
*/

/*
    HWND hWnd = Jau.run("powerpoint"); 
         // fails since not the name of the application;
         // you can check by calling:
    List<String> apps =  Jau.appListPaths();
    for(String app : apps)
      System.out.println(app);
*/

    // HWND hWnd = Jau.run("powerpnt", "Presentation"); 
         // needs a title since the first window that appears isn't the Powerpoint window

    // HWND hWnd = Jau.run("powerpnt.exe /C jauTest.pptx", "Presentation"); 
         // fails, since only no command line arguments are accepted

    // HWND hWnd = Jau.run("cmd /c compmgmt.msc", "Computer Management"); 
         // but cmd can be used to run a MMC snap-in (or DOS command)


    // ------------------ leave this bit alone -----------------
    if (hWnd != null) {
      Jau.sleep(2000);
      Jau.winClose(hWnd);
    }
    else
      System.out.println("Handle is null");
  }  // end of main()

}  // end of TestRun class
