
// UseCalc2.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/* Example used in the manual.
   Using the calculator's controls to calculate:
          23 + 20  via text sends to the calculator's text control

   The control IDs were found using WinSpy++
   (http://www.catch22.net/software/winspy-17).
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UseCalc2
{
  public static void main (String args[])
  {
    HWND hWnd = Jau.run("calc");  
    String winTitle = Jau.winGetTitle(hWnd);
    System.out.println("Title: \"" + winTitle +"\"");

    int inCtrlID = 0x96;   // in "Calculator" on my Windows 7 test machine
    if (winTitle.contains("Plus"))
     inCtrlID = 0x193;    // in "Calculator Plus" on my XP test machine

    Jau.controlSend(hWnd, inCtrlID, "23");   
    //Jau.sleep(1000);

    Jau.controlSend(hWnd, inCtrlID, "+", 1);   // use raw mode to send the "+"
    //Jau.sleep(1000);

    Jau.controlSend(hWnd, inCtrlID, "10");

    //Jau.sleep(1000);

    Jau.controlSend(hWnd, inCtrlID, "=");
    Jau.sleep(5000);     // so the user can see the result inside the calculator

    System.out.println("Result: " + Jau.controlGetText(hWnd, inCtrlID));
    Jau.winClose(hWnd);
  }  // end of main()

}  // end of UseCalc2 class
