
// UseComMgmt.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/*  Manipulate the "Computer Management" OS app using the
    tree and list-view controls.
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UseComMgmt
{
  public static void main (String args[])
  {
    HWND hWnd = Jau.run("cmd /c compmgmt.msc", "Computer Management"); 
          // this shows how to run a command line OS app

    printListView("Com Mgmt (Local)", hWnd, 0x31F2);

    // expand the "Event Viewer" sub-subitem in the tree view
    Jau.controlTreeView(hWnd, 0x31F1, "Select", "#0|#0|#0");
    Jau.sleep(1000);   // wait for the list view to be updated

    printListView("Event Viewer", hWnd, 0x31F2);

    if (hWnd != null) {
      Jau.sleep(5000);
      Jau.winClose(hWnd);
    }
  }  // end of main()



  private static void printListView(String listTitle, HWND hWnd, int ctrlID)
  // print out all the info in the list-view
  {
    System.out.println(listTitle);
    int numItems = Jau.toInt( Jau.controlListView(hWnd, ctrlID, "GetItemCount", "", "") );
    for (int i=0; i < numItems; i++) {
      Jau.controlListView(hWnd, ctrlID, "Select", ""+i, ""+i);
      // String title = Jau.controlListView(hWnd, ctrlID, "GetText", ""+i, "0");
      int numSubItems = Jau.toInt( 
               Jau.controlListView(hWnd, ctrlID, "GetSubItemCount", "", "") );
      //System.out.println(i + " : number of sub items: " + numSubItems);
      System.out.print("  " + i + ". ");
      String entry = null;
      for (int j=0; j < numSubItems; j++) {
        entry = Jau.controlListView(hWnd, ctrlID, "GetText", ""+i, ""+j);
        System.out.print("\"" + entry + "\", ");
      }
      System.out.println();
    }
    System.out.println("------------------------------------");
  }  // end of printListView()


}  // end of UseComMgmt class






