
// UseFirefox.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/* Use an already-running Firefox, or start a new instance, and then
   use it's search box to find a definition for an input word. Print
   the first 2000 characters of the web page result to stdout.

   This application works by sending control keys to Firefox. A list of
   these keyboard shortcuts can be found at:
     https://support.mozilla.org/en-US/kb/
                 keyboard-shortcuts-perform-firefox-tasks-quickly#w_windows-tabs
   Usage:
     run UseFirefox aesthetic
*/

import com.sun.jna.platform.win32.WinDef.*;

public class UseFirefox
{
  public static void main (String[] args)
  {
    if (args.length != 1) {
      System.out.println("Usage: run UseFirefox <word>");
      return;
    }

    // is firefox already running?
    HWND hWnd = Jau.appGetHandle("firefox");
    if (hWnd != null) {
      System.out.println("firefox already running");
      Jau.winActivate(hWnd);
    }
    else   // start a new instance
      hWnd = Jau.run("firefox");

    Jau.send(hWnd, "^t");    // ctrl + t == open a new tab
    Jau.send(hWnd, "^e");    // ctrl + e == enter search query
    Jau.sleep(2000); 

    // type word into search field
    Jau.send(hWnd, args[0] + " definition{ENTER}");
    Jau.sleep(5000);

    System.out.println("Selecting text...");
    Jau.send(hWnd, "^a");    //  ctrl + a == select all text
    Jau.send(hWnd, "^c");    //  ctrl + c == copy

    String webText = Jau.clipGet();
    if (webText.length() > 2000)
      webText = webText.substring(0, 2000);
    System.out.println(webText);
  }  // end of main()

}  // end of UseFirefox class






