
// UseNotepad2.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/* Another Notepad example.
    * move about in the text using shortcut keys
    * Exit using arrow keys
    * deal with secondary save window by 'clicking' the
      no button
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UseNotepad2
{
  public static void main (String args[])
  {
    HWND hWnd = Jau.run("notepad.exe");

    // type some text
    Jau.send("Hello from Notepad.{ENTER}1 2 3 4 5 6 7 8 9 10{ENTER}");
    Jau.sleep(1000);
    Jau.send("{UP 2}");    // move the caret up 2 lines
    Jau.send("Hello{ENTER}");
    Jau.sleep(1000);
    
    // quit by pressing Alt-F and then scrolling down (simulating the down arrow being 
    // pressed six times) to the Exit menu
    Jau.send("!f");
    Jau.sleep(2000);
    Jau.send("{DOWN 6}{ENTER}");
    
    // Now a screen will pop up and ask to save the changes, 
    // the window has the title "Notepad"
    Jau.winWaitActive("Notepad");
    Jau.sleep(500);
    
    // simulate the "TAB" key to move to the second button in which the "ENTER" is simulated to not "save the file"
    Jau.send("{TAB}{ENTER}");
    
    // wait for Notepad to close before continuing
    Jau.winWaitClose(hWnd);
  }  // end of main()

}  // end of UseNotepad2 class
