
// UsePP.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/*  Create a slide in Powerpoint, then close the application.
    Deal with the save dialog that appears, and a possible
    overwrite dialog if the file already exists.
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UsePP
{

  public static void main (String args[])
  {
    HWND hWnd = Jau.run("powerpnt", "Presentation");

    Jau.sleep(1000);
    System.out.println("Changing to title/points contents layout slide");
    Jau.send(hWnd, "!hl{HOME}{HOME}{TAB}");            
            // alt + h + l == home > layout
            // {HOME}{HOME}{TAB}{ENTER}  == start at left, move right once, select
    Jau.sleep(1000);   // wait a bit so we can see it
    Jau.send("{ENTER}");    

    // type text in title block
    System.out.println("Entering a title...");
    Jau.send(hWnd, "This is a title");

    // move to points block      
    Jau.send(hWnd, "{ESC}{ESC}{TAB}{TAB}");            
    System.out.println("Entering two points...");
    Jau.send(hWnd, "First Point{ENTER}");
    Jau.send(hWnd, "Second Point");


    Jau.sleep(3000);
    System.out.println("Closing without saving first");
    Jau.winClose(hWnd);

    Jau.winWaitActive("Microsoft");   // wait for the save window to appear
    Jau.sleep(1000);   // wait a bit so we can see it
    // System.out.println(" -- not saving");
    // Jau.send("!n");    // don't save

    System.out.println(" -- saving");
    Jau.send("!s");  // save

    Jau.winWaitActive("Save");  // wait for save dialogue window to appear
    String slideFnm = Jau.desktopPath() + "\\Jau Tests\\foo.pptx";
    System.out.println(" Saving to \"" + slideFnm + "\"");
    Jau.send(slideFnm);
    Jau.sleep(1000);   // wait a bit so we can see it
    Jau.send("{ENTER}");    
         // will only exit silently if there is no foo.pptx in the dir
         // probably saved in "My Documents"

    if (Jau.winWaitActive("Microsoft", 4)) {     // do you want to overwrite? dialogue on XP
    // if (Jau.winWaitActive("Confirm", 4)) {     // do you want to overwrite? dialogue
      System.out.println("Overwriting foo.pptx");
      Jau.sleep(1000);   // wait a bit so we can see it
      Jau.send("!y");     // yes
    }
  }  // end of main()

}  // end of UsePP class






