
// UsePaint.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/*  Draw "hi" with MS Paint, and save to a file on the desktop.
    Deal with the possibility that the file already exists.
    I used AU3Recorder to get the mouse coordinates.
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UsePaint
{
  public static void main(String args[])
  {
    HWND hWnd = Jau.run("mspaint");

    // position the window in a standard location so the
    // subsequent mouse click will probably work
    // Jau.winMaximize(hWnd);
    Jau.winMoveToTopEdge(hWnd);
    Jau.winMoveToLeftEdge(hWnd);

    // click on the spray can icon (let's hope this position is correct)
    Jau.mouseClick("left",23,164);

    drawHi();

    // save the image
    Jau.sleep(1000);
    Jau.send(hWnd, "!fa");      // alt-f-a == save-as

    // System.out.println("Desktop path: " + Jau.desktopPath());
    String hiFnm = Jau.desktopPath() + "\\hi.bmp";

    HWND saveHandle = Jau.winWaitActiveHandle("Save As");
    Jau.send(saveHandle, "!n");    // alt + n == focus on "File name" field
    Jau.send(hiFnm); 
    Jau.sleep(1000);   // wait a bit
    Jau.send("{ENTER}");

    Jau.sleep(1000);   // wait a bit before testing, to give time for windows to change
    if (Jau.winWaitActive("Save As", 2)) {     // do you want to overwrite? dialogue
      System.out.println("Overwriting hi.bmp");
      Jau.send("!y");     // alt + y == yes
    }
    else
      System.out.println("Writing hi.bmp");

    // close the app
    Jau.sleep(2000);
    Jau.winClose(hWnd);
  }  // end of main()


  private static void drawHi()
  {
    // lines for 'h'
    Jau.mouseMoveTo(180,161);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(181,299, 30);  // slow; default is 10
    Jau.mouseUp("left");

    Jau.mouseMoveTo(181,236);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(233,236);
    Jau.mouseUp("left");

    Jau.mouseMoveTo(236,242);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(236,298);
    Jau.mouseUp("left");

    // lines for 'i', including dot over 'i'
    Jau.mouseMoveTo(269,240);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(269,293);
    Jau.mouseUp("left");

    Jau.mouseMoveTo(270,219);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(269,219);
    Jau.mouseUp("left");

    Jau.mouseMoveTo(272,221);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(271,223);
    Jau.mouseUp("left");

    // underline
    Jau.mouseMoveTo(141,347);
    Jau.mouseDown("left");
    Jau.mouseMoveTo(336,347, 30);  // slow
    Jau.mouseUp("left");
  }  // end of drawHi()


}  // end of UsePaint class

