
// UseWord.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/*  Start Word, open a docx file, and then save it
    in PDF format, dealing with the possibility of 
    overwriting an existing PDF version.
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UseWord
{

  public static void main (String args[])
  {
    HWND hWnd = Jau.run("winword", "Document");

    Jau.send(hWnd, "^o");    // ctrl + o == open
    HWND openHandle = Jau.winWaitActiveHandle("Open");

    // type filename into title field
    String testFnm = Jau.desktopPath() + "\\Jau Tests\\test.docx";
    Jau.send(openHandle, testFnm);
    Jau.sleep(2000);   // so we can see the filename
    Jau.send(openHandle, "{ENTER}");

    HWND fileHandle = Jau.winWaitActiveHandle("test.docx");

    Jau.sleep(2000);
    Jau.send(hWnd, "{F12}");      // save-as

    HWND saveHandle = Jau.winWaitActiveHandle("Save As");
    Jau.send(saveHandle, "!t");    // alt + t == focus on "Save as type" field
    Jau.send("{DOWN 6}");    // move down to pdf option 
    Jau.sleep(1000);
    Jau.send("{ENTER}");

    // Jau.send(saveHandle, "!e");    // alt + e == uncheck open PDF file
    Jau.send(saveHandle, "!s");    // alt + s == "Save" button

    if (Jau.winWaitActive("Microsoft Word", 3)) {     // do you want to overwrite? dialogue
      System.out.println("Overwriting test.pdf");
      Jau.send("!y");     // alt + y == yes
    }
    else
      System.out.println("Writing test.pdf");

    Jau.sleep(2000);
    Jau.winClose(fileHandle);
  }  // end of main()

}  // end of UseWord class
