
// UseXnView.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2014

/*  Open XnView, read in a JPG file, and then save it
    in PNG format, dealing with the possibility that
    an existing copy may need to be overwritten.
*/

import com.sun.jna.platform.win32.WinDef.*;


public class UseXnView
{

  public static void main (String args[])
  {
    HWND hWnd = Jau.run(Jau.appsDir() + "\\XnView\\xnview.exe");

    Jau.send(hWnd, "^o");    // ctrl + o == open
    HWND openHandle = Jau.winWaitActiveHandle("Open");

    // type filename into title field
    System.out.println("Reading in library.jpg image");
    // String testFnm = Jau.desktopPath() + "\\Jau Tests\\library.jpg";
    String testFnm = Jau.userDir() + "\\library.jpg";

    Jau.send(openHandle, testFnm);
    Jau.sleep(1000);   // so we can see the filename
    Jau.send(openHandle, "{ENTER}");

    Jau.sleep(1000);
    System.out.println("Saving in PNG format");
    Jau.send(hWnd, "^S");    // ctrl + shift + s == save as
    HWND saveHandle = Jau.winWaitActiveHandle("Save");

    Jau.controlClick(saveHandle, 0x470);   // click on "Save as type" field
    Jau.send("{PGUP 5}");    // make sure at top of combo list
    Jau.send("{DOWN 5}");    // move down to png option 
    Jau.sleep(1000);
    Jau.send("{ENTER}");

    Jau.send(saveHandle, "!s");    // alt + s == "Save" button

    Jau.sleep(1000);
    if (Jau.winWaitActive("Save", 3)) {     // do you want to overwrite? dialogue
      System.out.println("Overwriting library.png");
      Jau.send("!y");     // alt + y == yes
    }
    else
      System.out.println("Writing library.png");

    Jau.sleep(2000);
    Jau.winClose(hWnd);
  }  // end of main()

}  // end of UseXnView class

